/*
 * RcxCtrlGUI.java
 *
 * Created on November 17, 2002, 3:16 PM
 */

package RcxCtrl;

import java.awt.*;
import java.awt.image.*;
import java.net.*;
import java.io.*;
import java.lang.Exception.*;
import javax.swing.*;
import java.awt.event.*;
/**
 *
 * @author  Haihui Huang
 */
public class RcxCtrlGUI extends javax.swing.JFrame implements ActionListener {
    
    /** Creates new form RcxCtrlGUI */
    public RcxCtrlGUI() {
        initComponents();
        if( resetTimer == null)       // new Timer for the first time
            resetTimer = new Timer(2, this);
        resetTimer.start();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanelTop = new javax.swing.JPanel();
        jPanelLeft = new javax.swing.JPanel();
        jPanelCmd = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldIpAddr = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldTcpPort = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jTextFieldDestLnpAddr = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldDestPort = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextFieldSrcLnpAddr = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldSrcPort = new javax.swing.JTextField();
        guyStandIcon = new ImageIcon("RcxCtrl/images/guy_stand.gif");
        guyWalkIcon = new ImageIcon("RcxCtrl/images/guy_walk.gif");

        jButtonConnect = new javax.swing.JButton();
        if( lnpdSocket == null){
            jButtonConnect.setIcon(guyStandIcon);
        }
        else
        {
            jButtonConnect.setIcon(guyWalkIcon);
        }
        jButtonExit = new javax.swing.JButton();
        jPanelCtrl = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldSpeed = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldDirect = new javax.swing.JTextField();
        jButtonSend = new javax.swing.JButton();
        jButtonGet = new javax.swing.JButton();
        jPanelRcxImage = new javax.swing.JPanel();
        turnLeftIcon = new ImageIcon("RcxCtrl/images/turnLeft.jpg");
        turnLeftIconHL = new ImageIcon("RcxCtrl/images/turnLeftHL.jpg");

        jButtonTurnLeft = new javax.swing.JButton();
        jButtonTurnLeft.setIcon(turnLeftIcon);

        rcxBigIcon = new ImageIcon("RcxCtrl/images/rcx.gif");

        jButtonSpeedometer = new javax.swing.JButton();
        jButtonSpeedometer.setIcon(rcxBigIcon);
        turnRightIcon = new ImageIcon("RcxCtrl/images/turnRight.jpg");
        turnRightIconHL = new ImageIcon("RcxCtrl/images/turnRightHL.jpg");

        jButtonTurnRight = new javax.swing.JButton();
        jButtonTurnRight.setIcon(turnRightIcon);

        forwardIcon = new ImageIcon("RcxCtrl/images/speed.jpg");

        jButtonForward = new javax.swing.JButton();
        backwardIcon = new ImageIcon("RcxCtrl/images/carRear.jpg");
        backwardIconHL = new ImageIcon("RcxCtrl/images/carRearHL.jpg");

        jButtonBackward = new javax.swing.JButton();
        jButtonBackward.setIcon(backwardIcon);

        getContentPane().setLayout(new java.awt.GridLayout(1, 1));

        setName("RcxCtrlFrame");
        addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                OnChange(evt);
            }
        });

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanelTop.setLayout(new java.awt.GridLayout(1, 2));

        jPanelLeft.setLayout(new java.awt.GridLayout(2, 1));

        jPanelCmd.setLayout(new java.awt.GridLayout(7, 2));

        jPanelCmd.setBorder(new javax.swing.border.TitledBorder("Connection settings"));
        jLabel1.setText("LNPD Host IP Addr:");
        jPanelCmd.add(jLabel1);

        jTextFieldIpAddr.setToolTipText("IP address of Host running LNPD");
        jTextFieldIpAddr.setText("os27.csc.ncsu.edu");
        jPanelCmd.add(jTextFieldIpAddr);

        jLabel2.setText("TCP Port Number:");
        jPanelCmd.add(jLabel2);

        jTextFieldTcpPort.setText("7776");
        jPanelCmd.add(jTextFieldTcpPort);

        jLabel7.setText("Dest. LNP Addr:");
        jPanelCmd.add(jLabel7);

        jTextFieldDestLnpAddr.setText("0");
        jPanelCmd.add(jTextFieldDestLnpAddr);

        jLabel5.setText("Dest. LNP Port:");
        jPanelCmd.add(jLabel5);

        jTextFieldDestPort.setText("2");
        jPanelCmd.add(jTextFieldDestPort);

        jLabel8.setText("Src. LNP Addr:");
        jPanelCmd.add(jLabel8);

        jTextFieldSrcLnpAddr.setText("8");
        jPanelCmd.add(jTextFieldSrcLnpAddr);

        jLabel6.setText("Src. LNP Port:");
        jPanelCmd.add(jLabel6);

        jTextFieldSrcPort.setText("7");
        jPanelCmd.add(jTextFieldSrcPort);

        jButtonConnect.setText("Connect");
        jButtonConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OnConnect(evt);
            }
        });

        jPanelCmd.add(jButtonConnect);

        jButtonExit.setText("Exit");
        jButtonExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OnExit(evt);
            }
        });

        jPanelCmd.add(jButtonExit);

        jPanelLeft.add(jPanelCmd);

        jPanelCtrl.setLayout(new java.awt.GridLayout(3, 2, 1, 1));

        jPanelCtrl.setBorder(new javax.swing.border.TitledBorder("RCX Control Parameters"));
        jLabel3.setText("Speed:");
        jPanelCtrl.add(jLabel3);

        jTextFieldSpeed.setText("0");
        jPanelCtrl.add(jTextFieldSpeed);

        jLabel4.setText("Direction:");
        jPanelCtrl.add(jLabel4);

        jTextFieldDirect.setText("Forward");
        jPanelCtrl.add(jTextFieldDirect);

        jButtonSend.setText("Send Cmd");
        jButtonSend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OnSendCmd(evt);
            }
        });

        jPanelCtrl.add(jButtonSend);

        jButtonGet.setText("Get Status");
        jButtonGet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OnGetStatus(evt);
            }
        });

        jPanelCtrl.add(jButtonGet);

        jPanelLeft.add(jPanelCtrl);

        jPanelTop.add(jPanelLeft);

        jPanelRcxImage.setLayout(new java.awt.BorderLayout());

        jPanelRcxImage.setBorder(new javax.swing.border.TitledBorder("RCX"));
        jPanelRcxImage.setPreferredSize(new java.awt.Dimension(400, 600));
        jPanelRcxImage.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                CtrlKeyHandler(evt);
            }
        });

        jButtonTurnLeft.setPreferredSize(new java.awt.Dimension(60, 30));
        jButtonTurnLeft.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ButtonTurnLeft(evt);
            }
        });

        jPanelRcxImage.add(jButtonTurnLeft, java.awt.BorderLayout.WEST);

        jButtonSpeedometer.setPreferredSize(new java.awt.Dimension(160, 120));
        jButtonSpeedometer.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jButtonSpeedometerKeyPressed(evt);
            }
        });

        jPanelRcxImage.add(jButtonSpeedometer, java.awt.BorderLayout.CENTER);

        jButtonTurnRight.setPreferredSize(new java.awt.Dimension(60, 30));
        jButtonTurnRight.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ButtonTurnRight(evt);
            }
        });

        jPanelRcxImage.add(jButtonTurnRight, java.awt.BorderLayout.EAST);

        jButtonForward.setPreferredSize(new java.awt.Dimension(35, 60));
        jButtonForward.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ButtonForward(evt);
            }
        });

        jPanelRcxImage.add(jButtonForward, java.awt.BorderLayout.NORTH);

        jButtonBackward.setPreferredSize(new java.awt.Dimension(35, 60));
        jButtonBackward.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ButtonBackward(evt);
            }
        });

        jPanelRcxImage.add(jButtonBackward, java.awt.BorderLayout.SOUTH);

        jPanelTop.add(jPanelRcxImage);

        getContentPane().add(jPanelTop);

        pack();
    }//GEN-END:initComponents

    private void ButtonForward(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ButtonForward
        // Add your handling code here:
        CmdForward();
    }//GEN-LAST:event_ButtonForward

    private void ButtonBackward(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ButtonBackward
        // Add your handling code here:
        CmdBackward();
    }//GEN-LAST:event_ButtonBackward

    private void ButtonTurnRight(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ButtonTurnRight
        // Add your handling code here:
        CmdTurnRight();
    }//GEN-LAST:event_ButtonTurnRight

    private void ButtonTurnLeft(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ButtonTurnLeft
        // Add your handling code here:
        CmdTurnLeft();
    }//GEN-LAST:event_ButtonTurnLeft

    private void jButtonSpeedometerKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButtonSpeedometerKeyPressed
        // Add your handling code here:
        int keyCode = evt.getKeyCode();

        switch(keyCode) {
            case KeyEvent.VK_RIGHT:
                CmdTurnRight();
                break;
            case KeyEvent.VK_DOWN:
                CmdBackward();
                break;
            case KeyEvent.VK_LEFT:
                CmdTurnLeft();
               break;
            case KeyEvent.VK_UP:
                CmdForward();
                break;
            case KeyEvent.VK_S:
                CmdStop();
                //System.out.println("'s' pressed");
                break;
                
            default:
                System.out.println("key"+keyCode+"("+KeyEvent.getKeyText(keyCode) + ")");
                resetFlag = 0;
                beep(1);
                break;
        }
        resetCount = 100;    // 200 ms
        resetTimer.restart();
        //}
        //catch(InterruptedException e){
        //}
    }//GEN-LAST:event_jButtonSpeedometerKeyPressed

    private void CtrlKeyHandler(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_CtrlKeyHandler
        // Add your handling code here:
        int keyCode = evt.getKeyCode();
        System.out.println("keyCode="+keyCode+"("+KeyEvent.getKeyText(keyCode) + ")");
    }//GEN-LAST:event_CtrlKeyHandler

    private void OnChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_OnChange
        // Add your handling code here:
        displayImage(false);
    }//GEN-LAST:event_OnChange

    private void OnGetStatus(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OnGetStatus
        // Add your handling code here:
    }//GEN-LAST:event_OnGetStatus

    private void OnSendCmd(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OnSendCmd
        // Add your handling code here:
        displayImage(true);
        beep(1);
    }//GEN-LAST:event_OnSendCmd

    private void OnExit(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OnExit
        // Add your handling code here:
        cleanUp();
        System.exit(0);
    }//GEN-LAST:event_OnExit

    private void ConnectToLnpd(){
        String host = "os27.csc.ncsu.edu";
        try {
            host = jTextFieldIpAddr.getText();
            tcpPort = Integer.parseInt(jTextFieldTcpPort.getText());
            srcLnpPort = Byte.parseByte(jTextFieldSrcPort.getText());
            destLnpPort = Byte.parseByte(jTextFieldDestPort.getText());
            //System.out.print("Addr: " + host + ":"+ (new Integer(tcpPort).toString()));
            //System.out.println("  Src LNP Port: " + srcLnpPort + "   Dest LNP Port:"+ destLnpPort);
        } catch ( NullPointerException e )
        {
            System.err.println("Bad ip address or port");
            //System.exit(1);
        }
        
        try {
            InetAddress IA = InetAddress.getByName(host);
            //System.out.println("IP address: " +IA.toString());
            lnpdSocket = new Socket(IA, tcpPort);
            lnpdSocket.setKeepAlive(true);
            inStream = lnpdSocket.getInputStream();
            outStream = lnpdSocket.getOutputStream();
            //out = new PrintWriter(lnpdSocket.getOutputStream(), true);
            //out = new ByteArrayOutputStream(lnpdSocket.getOutput
            //in = new BufferedReader(new InputStreamReader(lnpdSocket.getInputStream()));
            //char ping[] = {0xf1, 0x06, 0x02, 0x87, '0', '0', '0', '1', 0x40};
           jButtonConnect.setText("Disconnect");
           jButtonConnect.setIcon(guyWalkIcon);
            //out.println(ping);
            
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: " + host);
            //System.exit(1);
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for the connection ");
            //System.exit(1);
        }        
    }
    private void OnConnect(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OnConnect
        // Add your handling code here:       
        if( lnpdSocket != null)
        {
            cleanUp();
            jButtonConnect.setText("Connect");
            if( aniTimer != null)   
                aniTimer.stop();
            return;
        }
 
        gui.ConnectToLnpd();
        
        try {
            byte ping[] = {(byte)0xf1, (byte)0x06, (byte)0x02, (byte)0x87, 
                        '0', '0', '0', '1', 
                        (byte)0x40};
            lnpdSocket.getOutputStream().write(ping);
            //lnpdSocket.getOutputStream().flush();
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for the connection ");
            //System.exit(1);
        }        

        //displayImage(true);
        if( aniTimer == null)       // new Timer for the first time
            aniTimer = new Timer(500, this);
        aniTimer.start();
    }//GEN-LAST:event_OnConnect
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        cleanUp();
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        //new RcxCtrlGUI().show();
        gui = new RcxCtrlGUI();
        udpSrvTh = new UDPServerThread();
        udpSrvTh.start();
        gui.show();
        displayImage(false);
        
    }
    
    public static void beep(int beepTimes) {
        Toolkit tk = Toolkit.getDefaultToolkit();
        for(int i = 0; i < beepTimes; i++)     tk.beep();
    }    
    
    public static void cleanUp() {
        try{
            if( out != null) out.close();
            out = null;
            
            if( in != null) in.close();
            in = null;
            if(lnpdSocket != null) lnpdSocket.close();
            lnpdSocket = null;
        } catch( IOException e)
        {   System.exit(1);
        }
    }
    
    public static void displayImage(boolean bForce) {
        return;
    }

    public void actionPerformed(ActionEvent e) {
        // there are two cases that we will get into this functions
        // triggered by two timers
        if( lnpdSocket != null)
        {
            
            try{
                //inStream = lnpdSocket.getInputStream();
                if( inStream.available()  > 0 ) {
                    inputChar = inStream.read(); 
                    //System.err.print("");
                    //System.err.print( pf.sprintf( inputChar & 0x000000FF ) );
                    //System.err.println();
                    if( receive_byte( (byte)inputChar ) > 0)
                    {
                        //System.err.print("{");
                        //System.err.print(pf.sprintf( addrBuf[0] & 0x000000ff ) );
                        //System.err.print("}");
                        // processing addressing packet here
                        
                        addrBuf[0] = (byte) 0;      // clear the addressing buffer
                    }
                    
                }
            }catch(IOException ioe) {
                ioe.printStackTrace(System.err);
            }
        }
        if( e.getSource() == resetTimer ){    // reset timer asked to clear flags
            if( resetFlag > 0)
            {
                resetCount --;
                if( resetCount <= 0 ) {
                    
                    switch(resetFlag) {
                        case 1: // East border
                            jButtonTurnRight.setIcon(turnRightIcon);
                            //beep(1);
                            break;
                        case 2: // South border
                            jButtonBackward.setIcon(backwardIcon);
                            break;
                        case 3: // West border
                            jButtonTurnLeft.setIcon(turnLeftIcon);
                            //beep(1);
                            break;
                        case 4: // North border
                            break;
                        default:
                            jButtonTurnRight.setIcon(turnRightIcon);
                            jButtonTurnLeft.setIcon(turnLeftIcon);
                            break;
                    }
                    resetFlag = 0;
                    //resetCount = 100;    // 200 ms
                }
            }
            return;
        }
        //if(lnpdSocket == null) return;
        timerFlag ++;
        if( timerFlag % 2 == 0){
            jButtonConnect.setIcon(guyWalkIcon);
            //jButtonTurnLeft.setIcon(turnLeftIconHL);
            //jButtonTurnRight.setIcon(turnRightIconHL);
            jButtonBackward.setIcon(backwardIcon);
        }
        else{
            jButtonConnect.setIcon(guyStandIcon);
            jButtonTurnLeft.setIcon(turnLeftIcon);
            jButtonTurnRight.setIcon(turnRightIcon);
        }
    }
    
    public static byte lnp_checksum( byte[] data, int length ) {
        byte a = (byte)0xff;
        byte b = (byte)0xff;
        
        while (length > 0) {
            a = (byte)(a + data[length-1]);
            b = (byte)(b + a);
            length--;
        }
        
        return (byte)(a + (b << 8));
    }
    
    public static int lnp_logical_write(byte[] data, byte length) {
        byte i;
        if (lnpdSocket == null) return TX_ERROR;
        try{
            //outStream = lnpdSocket.getOutputStream();
            outStream.write(data, 0, (int)length);
            //outStream.flush();
            //System.err.print("\n[");
            //for(i=0; i<length; i++)
            //    System.err.print( pf.sprintf( ((int)(data[i]))&0x000000FF ) );
            //System.err.print("] ");
            return TX_SUCCESS;
        } catch (IOException e) {
            //System.err.println("Reconnect to LNPD for 'broken pipe'");
            try{
                if( lnpdSocket != null) {
                    cleanUp();
                }
                gui.ConnectToLnpd();
                //outStream = lnpdSocket.getOutputStream();
                outStream.write(data, 0, (int)length);
                //outStream.flush();
                //System.err.print("\n[ ");
                //for(i=0; i<length; i++)
                //    System.err.print( pf.sprintf( ((int)(data[i]))&0x000000FF ) );
                //System.err.print("] ");
                return TX_SUCCESS;
            }
            catch (IOException e2){
                System.err.println("Socket IOException: broken pipe ");
                e2.printStackTrace(System.err);
                //System.exit(1);
                return TX_FAILURE;
            }
        }
    }
    
    public static int lnp_integrity_write(byte[] data, byte length) {
        lnp_buffer[0]=(byte)0xf0;
        lnp_buffer[1]=length;
        //memcpy(lnp_buffer+2,data,length);
        for(int i = 0; i<length; i++)
            lnp_buffer[i+2] = data[i];
        lnp_buffer[length+2]= lnp_checksum(lnp_buffer,length+2);
        
        return lnp_logical_write(lnp_buffer,(byte)(length+3));
    }
    
    public static int lnp_addressing_write(byte[] data, byte length, byte dest, byte srcport) {
        lnp_buffer[0]=(byte)0xf1;
        lnp_buffer[1]=(byte)(length+2);
        lnp_buffer[2]=dest;
        lnp_buffer[3]=(byte)((byte)(srcLnpAddr<<4) | (byte)(srcport & DEFAULT_LNP_PORT_MASK) );
        //memcpy(lnp_buffer+4,data,length);
        for(int i = 0; i<length; i++)
            lnp_buffer[i+4] = data[i];
        lnp_buffer[length+4]=lnp_checksum(lnp_buffer,length+4);
        //System.err.print("\n[");
        //for(int i=0; i<length; i++)
        //    System.err.print( pf.sprintf( ((int)(data[i]))&0x000000FF ) );
        //System.err.print("] ");
        
        return lnp_logical_write(lnp_buffer,(byte)(length+5));
    }
    
    public static int lnp_receive_packet(byte[] data) {
        byte header = data[0];
        byte length = data[1];
        byte dest;
        byte port;
        byte src;
        // only handle non-degenerate packets in boot protocol 0xf0
        //
        switch(header) {
            case (byte)0xf1:	      // addressing layer.
                if(length>2) {
                    dest=data[2];
                    src= data[3];
                    for( int i =0; i< length-2; i++)    // copy data
                        addrBuf[i] = data[i+4];
                    return (length-2);
                }
                break;
            default:
                break;
        } // switch(header)
        return 0;
    }
    
    public static int transmit_ack() {
        byte ack_byte[] = new byte[2];
        ack_byte[0] = LNPD_ACK_OK;
        if( lnp_logical_write(ack_byte, (byte)1) != TX_SUCCESS)
            return -1;
        else return 0;
    }
    
    public static int receive_byte(byte byte_read) {
        
        if(rcv_state==RCV_WAIT_FIRST)
            bytesRead=0;
        
        buffer[bytesRead++]=byte_read;
        
        switch(rcv_state) {
            case RCV_WAIT_FIRST:
                switch ( byte_read ) {
                    case LNPD_ACK_OK:
                        tx_result = TX_SUCCESS;
                        tx_active = 0;
                        //System.err.print("ACK ");
                        break;
                    case LNPD_ACK_BAD:
                        tx_result = TX_FAILURE;
                        tx_active = 0;
                        //System.err.print("NAK ");
                        break;
                    default:
                        rcv_state++;
                }
                break;
            case RCV_WAIT_LEN:
                endOfData=byte_read+3;
                rcv_state++;
                break;
            case RCV_WAIT_DATA:
                if (bytesRead == endOfData) {
                    rcv_state = RCV_WAIT_FIRST;
                    if ( transmit_ack() < 0) return -1;
                    if ( (tx_active==0 ) )   //&& discard_while_tx) )
                        return lnp_receive_packet(buffer);
                }
        }
        return 0;
    }
    
    public void CmdForward() {
        Graphics2D biContext;
        int         absSpeed;
        Polygon     poly;
        
        if(curSpeed < 255) curSpeed+=8;
        else{
            beep(1); return;
        }
        if( curSpeed < 0 )
            curSpeed = ((curSpeed-1) / 8) * 8;  // force to be multiple of 8
        else
            curSpeed = ((curSpeed+1) / 8) * 8;  // force to be multiple of 8
        if( curSpeed > 255) curSpeed = 255;
        
        // issue ACCELERATE cmd to rcx
        cmd_buffer[0] = FWD_CMD;
        lnp_addressing_write(cmd_buffer, (byte)1, destLnpPort,  srcLnpPort);
        
        if( curSpeed < 0 )
            absSpeed = - curSpeed;
        else
            absSpeed = curSpeed;
        if( curSpeed > 0 )
            jTextFieldDirect.setText("Forward");
        else if(curSpeed < 0 )
            jTextFieldDirect.setText("Backward");
        else
            jTextFieldDirect.setText("Stopped");
        
        //if( curSpeed < 0 )      jButtonForward.repaint();
        
        biContext = (Graphics2D)jButtonForward.getGraphics();
        w = jButtonForward.getWidth();
        h = jButtonForward.getHeight();
        ih = forwardIcon.getIconHeight();
        dy = (h - ih)/2;
        x = absSpeed * w / 255;
        y = x * ih / w;
        //biContext.setColor(new Color(255,255,255) );
        //biContext.fillRect(0, 0, w, h );
        poly = new Polygon();
        if( curSpeed > 0) {
            biContext.setColor(lineColor);      // Green color
            poly.addPoint(0, h - dy);
            poly.addPoint(x, h-dy);
            poly.addPoint(x, h-dy-y);
        }
        else {
            biContext.setColor(lineColor2);     // Blue
            poly.addPoint(w, h - dy);
            poly.addPoint(w-x, h-dy);
            poly.addPoint(w-x, h-dy-y);
        }
        //biContext.drawLine(x-1, h-dy, x-1, h-dy-y);
        //biContext.drawLine(x, h-dy, x, h-dy-y);
        //biContext.drawLine(x+1, h-dy, x+1, h-dy-y);
        //biContext.fillPolygon(poly);
        
        biContext.dispose();
        jTextFieldSpeed.setText( new Integer(curSpeed).toString());
        resetFlag = 4;
        
    }
    
    public void CmdBackward() {
        Graphics2D biContext;
        int         absSpeed;
        Polygon     poly;
        
        //jButtonForward.setIcon(forwardIcon);
        if( curSpeed > -255) curSpeed-=8;
        else{
            beep(1); return;
        }
        if( curSpeed < 0 )
            curSpeed = ((curSpeed-1) / 8) * 8;  // force to be multiple of 8
        else
            curSpeed = ((curSpeed+1) / 8) * 8;  // force to be multiple of 8
        
        if( curSpeed < -255) curSpeed = -255;
        
        // issue BRAKE cmd to rcx
        cmd_buffer[0] = BWD_CMD;
        lnp_addressing_write(cmd_buffer, (byte)1, destLnpPort,  srcLnpPort);
        
        if( curSpeed < 0 )
            absSpeed = - curSpeed;
        else
            absSpeed = curSpeed;
        
        if( curSpeed > 0 )
            jTextFieldDirect.setText("Forward");
        else if(curSpeed < 0 )
            jTextFieldDirect.setText("Backward");
        else
            jTextFieldDirect.setText("Stopped");
        jButtonBackward.setIcon(backwardIconHL);
        
        //if( curSpeed > 0 )  jButtonForward.repaint();
        
        biContext = (Graphics2D)jButtonForward.getGraphics();
        
        w = jButtonForward.getWidth();
        h = jButtonForward.getHeight();
        ih = forwardIcon.getIconHeight();
        dy = (h - ih)/2;
        x = absSpeed * w / 255;
        y = x * ih / w;
        //biContext.setColor(new Color(255,255,255) );
        //biContext.fillRect(0, 0, w, h );
        poly = new Polygon();
        if( curSpeed > 0) {
            biContext.setColor(lineColor);      // Green color
            poly.addPoint(0, h - dy);
            poly.addPoint(x, h-dy);
            poly.addPoint(x, h-dy-y);
        }
        else {
            biContext.setColor(lineColor2);     // Blue
            poly.addPoint(w, h - dy);
            poly.addPoint(w-x, h-dy);
            poly.addPoint(w-x, h-dy-y);
        }
        //poly.addPoint(0, h-dy);
        //biContext.fillPolygon(poly);
        //biContext.drawLine(x-1, h-dy, x-1, h-dy-y);
        //biContext.drawLine(x, h-dy, x, h-dy-y);
        //biContext.drawLine(x+1, h-dy, x+1, h-dy-y);
        biContext.dispose();
        jTextFieldSpeed.setText( new Integer(curSpeed).toString());
        resetFlag = 2;
        
    }
    
    public void CmdTurnLeft() {
        // issue turning left cmd to rcx
        cmd_buffer[0] = LEFT_CMD;
        lnp_addressing_write(cmd_buffer, (byte)1, destLnpPort,  srcLnpPort);
        jButtonTurnLeft.setIcon(turnLeftIconHL);
        jTextFieldDirect.setText("Left-turn");
        resetFlag = 3;
        
    }
    
    public void CmdTurnRight() {
        // issue turning RIGHT cmd to rcx
        cmd_buffer[0] = RIGHT_CMD;
        lnp_addressing_write(cmd_buffer, (byte)1, destLnpPort,  srcLnpPort);
        jButtonTurnRight.setIcon(turnRightIconHL);
        jTextFieldDirect.setText("Right-turn");
        resetFlag = 1;
        //Thread.currentThread().sleep(50);
        //jButtonTurnRight.setIcon(turnRightIcon);
    }
    
    public void CmdStop() {
        // issue stop cmd to rcx
        cmd_buffer[0] = STOP_CMD;
        lnp_addressing_write(cmd_buffer, (byte)1, destLnpPort,  srcLnpPort);
        jButtonBackward.setIcon(backwardIconHL);
        curSpeed = 0;
        jTextFieldSpeed.setText("0");
        jTextFieldDirect.setText("stopped");
        resetFlag = 0;
    }
    
    public void UpdateWebImage(int frameNo)
    {
        try{
            String fileName = (new Integer(frameNo).toString() ) + ".jpg"; 
            rcxBigIcon = new ImageIcon(fileName);

            jButtonSpeedometer.setIcon(rcxBigIcon);
			File f = new File(fileName);
			f.delete();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
public void UpdateWebImage(byte[] imgData)
{
	try{
		//String fileName = (new Integer(frameNo).toString() ) + ".jpg";
		rcxBigIcon = new ImageIcon(imgData);

		jButtonSpeedometer.setIcon(rcxBigIcon);
		//File f = new File(fileName);
		//f.delete();
	}
	catch(Exception e){
		e.printStackTrace();
	}
}
// Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonSpeedometer;
    private javax.swing.JPanel jPanelTop;
    private javax.swing.JButton jButtonGet;
    private javax.swing.JButton jButtonSend;
    private javax.swing.JTextField jTextFieldSpeed;
    private javax.swing.JButton jButtonBackward;
    private javax.swing.JButton jButtonTurnLeft;
    private javax.swing.JTextField jTextFieldDirect;
    private javax.swing.JButton jButtonExit;
    private javax.swing.JTextField jTextFieldSrcLnpAddr;
    private javax.swing.JTextField jTextFieldDestLnpAddr;
    private javax.swing.JPanel jPanelCmd;
    private javax.swing.JButton jButtonForward;
    private static javax.swing.JPanel jPanelRcxImage;
    private javax.swing.JButton jButtonConnect;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField jTextFieldSrcPort;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanelCtrl;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextFieldDestPort;
    private javax.swing.JTextField jTextFieldTcpPort;
    private javax.swing.JButton jButtonTurnRight;
    private javax.swing.JPanel jPanelLeft;
    private javax.swing.JTextField jTextFieldIpAddr;
    // End of variables declaration//GEN-END:variables
    private static Socket lnpdSocket = null;
    private static OutputStream outStream = null;
    private static InputStream inStream = null;
    private static PrintWriter out = null;
    //private static ByteArrayOutputStream out = null;
    private static BufferedReader in = null;
    private static int      tcpPort = 7776;
    private static Image  rcxImage = null;
    private static Icon     guyStandIcon = null;
    private static Icon     guyWalkIcon = null;
    public  static Icon     rcxBigIcon = null;
    private static Icon     turnLeftIcon = null;
    private static Icon     turnRightIcon = null;
    private static Icon     backwardIcon = null;
    private static Icon     forwardIcon = null;
    private static Icon     turnLeftIconHL = null;      // highlighted icon
    private static Icon     turnRightIconHL = null;     // highlighted icon
    private static Icon     backwardIconHL = null;
    private static Icon     forwardIconHL = null;
    private static byte     srcLnpAddr = 8;
    private static byte     srcLnpPort = 7;
    private static byte     destLnpAddr = 0;
    private static byte     destLnpPort = 2;
    private static byte     lnp_buffer[] = new byte[255];
    private static byte     cmd_buffer[] = new byte[255];
    //========================================================================
    // LNPD client implementation
    private static byte   TX_SUCCESS = 0;
    private static byte   TX_FAILURE = 1;
    private static byte  TX_ERROR = 2;
    private static byte   DEFAULT_LNP_ADDR = (byte)0x80;
    private static byte   DEFAULT_LNP_MASK = (byte)0xF0;
    private static byte   DEFAULT_LNP_PORT_MASK = (byte)0x0F;
    private static final byte   LNPD_ACK_OK = (byte) 0x33;
    private static final byte   LNPD_ACK_BAD = (byte) 0x77;
    private static final byte     RCV_WAIT_FIRST = (byte)0;
    private static final byte     RCV_WAIT_LEN = (byte)1;
    private static final byte     RCV_WAIT_DATA = (byte)2;
    private static byte     rcv_state = RCV_WAIT_FIRST;
    private static int     MAX_LNP_PACKET = (256+3);
    private static byte buffer[] = new byte[MAX_LNP_PACKET];
    private static byte addrBuf[] = new byte[MAX_LNP_PACKET];
    private static int bytesRead,endOfData;
    private static int tx_active;
    private static byte tx_result;

    //========================================================================
    private static int inputChar;
    private static Timer  aniTimer = null;
    private static Timer  resetTimer = null;
    private static int    resetFlag = 0;    // 1 for east, 2: south, 3: west, 4:north
    private static int    resetCount = 100;  // 200 ms
    private static int      timerFlag = 0;
    private static int      curSpeed = 0;
    private static Color    lineColor = new Color(0, 255, 0);
    private static Color    lineColor2= new Color(0, 0, 255);
    int w=1, h=1, x=1, y=1, ih=1, dy=1;
    private static byte     STOP_CMD    = (byte)0x05;
    private static byte     FWD_CMD     = (byte)0x01;
    private static byte     BWD_CMD     = (byte)0x02;
    private static byte     LEFT_CMD    = (byte)0x03;
    private static byte     RIGHT_CMD   = (byte)0x04;

    private static PrintfFormat pf = new PrintfFormat("%02x ");
    public static RcxCtrlGUI   gui = null;// = new RcxCtrlGUI();
    public static UDPServerThread udpSrvTh = null;  //new UDPServerThread();
}
